#include "main.h"

typedef enum {
	LEFT_TO_RIGHT,
	RIGHT_TO_LEFT
} State;

/* Global variable to hold current state */

static State currentState = RIGHT_TO_LEFT;

/* Event handlers implementations */

static void onLeftToRightTickImpl() {
	nextLeftLed(); // in main.h
}

static void onLeftToRightNextImpl() {
	resetLeds(); // in main.h
	currentState = RIGHT_TO_LEFT;
}

static void onRightToLeftTickImpl() {
	nextRightLed(); // in main.h
}

static void onRightToLeftNextImpl() {
	resetLeds(); // in main.h
	currentState = LEFT_TO_RIGHT;
}

void main (void) {

	initHardware(); // in main.h

	for (;;) {

		typedef enum {
			NEXT,
			TICK
		} Event;

		/* Default event to fire */

		Event eventToFire = TICK;

		/* Wait a little for button pressed. If so change eventToFire to NEXT */

 		for (unsigned int i = 5000; i; i--) {
			if (isNextButtonPressed()) {
				eventToFire = NEXT;
				break; // Fire NEXT event
			} 
		}

		switch (currentState) {
			case LEFT_TO_RIGHT : 
				switch (eventToFire) {
					case TICK:
						onLeftToRightTickImpl();
						break; // TICK
					case NEXT:
						onLeftToRightNextImpl();
						break; // NEXT
						
				}
				break; // LEFT_TO_RIGHT
			case RIGHT_TO_LEFT : 
				switch (eventToFire) {
					case TICK:
						onRightToLeftTickImpl();
						break; // TICK
					case NEXT:
						onRightToLeftNextImpl();
						break; // NEXT
						
				}
				break; // RIGHT_TO_LEFT
		}
	}
}
